# by plushpuffin@wwddfd.com
# Columnize Build News addon
push(@Addons_Loaded, 'Columnize 1.0');
$Addons_List{'Columnize'} = ['npa_columnize.pl', 'Build news in column-order instead of row-order - by <a href="mailto:plushpuffin@wwddfd.com">plushpuffin</a>'];

sub NewsCatFilterColumns {
	my $mintime = pop;
	$mintime = $mintime * 86400;
	$mintime = time - $mintime;
	my( $i, $nd, @NewNewsData, %filtcats );
	foreach $i (@_) {
		$filtcats{$i} = 1;
	}
	$filtcats{''} = $filtcats{'(default)'};
	delete $filtcats{'(default)'};
	$#NewNewsData = $#NewsData;
	$i = -1;
	foreach $nd (@NewsData) {
		# First, check if it matches the category.
		if ( $filtcats{'AllCategories'} || $filtcats{$nd->{'newscat'}} ) {
			# It matches. Now check the time.
			if ($nd->{'newstime'} >= $mintime && $nd->{'newstime'} <= $NC2_MIN_AGE ) {
				# It's good. Add to the new array.
				++$i;
				$NewNewsData[$i] = $nd;
			}
		}
	}
	$#NewNewsData = $i;

	# Below is the special part for turning it into columns.

	$CFCnumcolumns = 4;
	$CFCnumrows = 4;

	if( scalar @NewNewsData > $CFCnumcolumns * $CFCnumrows ) {
		$#NewNewsData = ( $CFCnumcolumns * $CFCnumrows ) - 1;
	}
	elsif( scalar @NewNewsData == 0 ) {
		$CFCnumrows = 1;
	}
	else {
		$CFCnumrows = int( scalar @NewNewsData / $CFCnumcolumns );
		if( scalar @NewNewsData > $CFCnumcolumns * $CFCnumrows ) {
			++$CFCnumrows;
		}
	}

	%CFCposition = ();
	$i = 0;
	foreach( @NewNewsData ) {
		$CFCposition{$_->{newsid}} = $i;
		++$i;
	}

	return	map { $_->[0] }
		sort { $b->[1] <=> $a->[1] }
		map {
			[
				$_,

				(
					( ( $CFCposition{$_->{newsid}} % $CFCnumrows ) * $CFCnumcolumns )
					+
					( $CFCposition{$_->{newsid}} / $CFCnumrows )
				)
			] } @NewNewsData;
}


sub DoColumnHTML {
	$newshtml = '';
	if( int( $CFCposition{$newsid} / $CFCnumrows ) == 0 ) {
		if( $NewsCounter != 1 ) {
			$newshtml .= qq~</tr>\n~;
		}
		$newshtml .= qq~<tr>\n~;
	}
	#
	#
	# CFC BEGIN EDITING HERE
	$newshtml .= qq~\t<td>$newssubject</td>\n~;
	# CFC STOP EDITING HERE
	#
	#
	if( $newsnum == 0 ) {
		$newshtml .= qq~</tr>\n~;
	}
}


1;